<template>
  <main>
    <div class="mt-container-small">
      <div class="columns is-centered">
        <div class="column">
          <mt-page-title link-text="retour" :link-to="profilLink({ name: page, query: { mois: queryMois } })">
            <div class="columns">
              <h1 class="has-text-weight-bold is-size-3 column is-narrow">{{ activite.nom }}</h1>
              <mt-pastille
                v-if="activitesEnfants.length > 0 || activiteParent"
                class="column is-narrow mt-margin"
                is-black
                size="27px"
                ><b-icon icon="share-variant" size="is-small"></b-icon>
              </mt-pastille>
            </div>
          </mt-page-title>
          <div class="columns mt-subtitle">
            <div class="column">
              <mt-tag-button-activity
                :text="detailType.libelle"
                :tag-class="detailType.class"
                :icon="detailType.icon"
              />
            </div>
            <div class="is-narrow">
              <div v-if="activiteParent" class="mt-inline popup">
                <mt-unite :organisme="activiteParent.organisme" unite-principale />
                <mt-pop-up-contact :organisme="activiteParent.organisme"></mt-pop-up-contact>
              </div>
              <div class="mt-inline">
                <mt-unite :organisme="activite.organisme" :unite-principale="!activiteParent" />
              </div>
              <div v-if="activitesEnfants.length > 0" class="mt-inline">
                <div v-for="(activiteEnfant, index) in activitesEnfants" :key="index" class="popup">
                  <mt-unite :organisme="activiteEnfant.organisme" :unite-principale="false" />
                  <mt-pop-up-contact :organisme="activiteEnfant.organisme"></mt-pop-up-contact>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="mt-date-range ">
      <div class="mt-container-small">
        <div class="columns is-centered mt-modifier">
          <nuxt-link
            v-if="isEmployeur || isAdmin"
            class="column is-narrow "
            :to="profilLink({ name: 'activites-id-editer', params: { id: activite.id }, query: { visu } })"
          >
            <b-button class="mt-button has-text-weight-semibold is-size-7 mt-button-fin " type="is-primary" expanded>
              Éditer l'activité
            </b-button>
          </nuxt-link>
          <div v-if="(isEmployeur || isAdmin) && !activite.idParent" class="column is-narrow">
            <b-button
              class="mt-button is-size-7 mt-button-fin has-text-weight-semibold"
              type="is-secondary"
              icon-left="layers"
              expanded
              @click="dupliquer"
            >
              Dupliquer
            </b-button>
          </div>
          <div v-if="(isEmployeur || isAdmin) && !activite.idParent" class="column is-narrow">
            <b-button
              class="mt-button is-size-7 mt-button-fin has-text-weight-semibold"
              type="is-secondary"
              expanded
              icon-left="share-variant"
              @click="ouvertShare = true"
            >
              Partager l'activité
            </b-button>
          </div>
          <div v-if="isEmployeur || isAdmin" class="column is-narrow">
            <b-button
              class="mt-button is-size-7 mt-button-fin has-text-weight-semibold"
              type="is-secondary"
              icon-left="delete"
              expanded
              @click="ouvertDelete = true"
            >
              Supprimer
            </b-button>
          </div>
        </div>
        <mt-date-range-long :start="activite.dateDebut" :end="activite.dateFin" />
        <div class="mt-description">
          <h4 class="has-text-weight-bold">Description de l'activité</h4>
          <p class="mt-preline">{{ activite.description }}</p>
        </div>
      </div>
    </div>
    <div class="mt-center">
      <div class="mt-container-small">
        <div class="columns is-centered mt-modifier">
          <nuxt-link
            v-if="isEmployeur || isAdmin"
            class="column is-narrow "
            :to="profilLink({ name: 'activites-id-participer', params: { id: activite.id }, query: { visu } })"
          >
            <b-button class="mt-button has-text-weight-semibold is-size-7 mt-button-fin " type="is-primary" expanded>
              Gérer les participants
            </b-button>
          </nuxt-link>
          <!-- A IMPLEMENTER PLUS TARD SI BESOIN-->
          <!--<div v-if="(isEmployeur || isAdmin) && !activite.idParent" class="column is-narrow">
            <b-button
              class="mt-button is-size-7 mt-button-fin has-text-weight-semibold"
              type="is-secondary"
              expanded
              icon-left="download"
            >
              Exporter
            </b-button>
          </div> -->
        </div>
        <div class="columns is-centered">
          <b-checkbox-button
            v-if="(isEmployeur || isAdmin) && activitesEnfants.length > 0"
            v-model="autresUnites"
            class="mt-type is-narrow"
          >
            Voir les participants des autres unités
          </b-checkbox-button>
        </div>
      </div>
      <div class="mt-participation">
        <section
          v-if="isEmploye && maParticipation && maParticipation.participer && maParticipation.participer.avancements"
          class="mt-pax margin-negative"
        >
          <mt-list-etapes-employe :participer="maParticipation.participer" />

          <div class="columns is-centered is-mobile">
            <div
              v-for="(action, index) in maParticipation.mesActions"
              :key="index"
              class="column is-narrow mt-margin-top"
            >
              <b-button
                type="is-primary"
                :disabled="disabledAction(action)"
                :title="maParticipationTitle(action)"
                class="mt-button is-size-8 has-text-weight-semibold"
                @click="openPopUpAction(action)"
              >
                {{ action.choix.nom }}
              </b-button>
            </div>
            <div v-if="isConvoque" class="column is-narrow mt-margin-top">
              <b-button v-if="bouton" type="is-primary" class="mt-button is-size-8" @click="actionPopup">
                Annuler ma participation
              </b-button>
            </div>
          </div>
        </section>
        <div v-if="autresUnites">
          <div class="mt-pax-subscribed bartext">
            <span class="is-size-9 has-text-weight-semibold">TOTAL</span>
          </div>
          <section class="mt-pax-subscribed mt-bottom">
            <mt-pax-decompte :avancement="avancementTotal" />
            <article>
              <mt-progress-pax-sub
                v-for="(effectif, index) in effectifTotal"
                :key="index"
                class="mt-progress-pax"
                :pax="effectif"
              />
            </article>
          </section>
          <div class="mt-pax-subscribed bartext">
            <span class="is-size-9 has-text-weight-semibold">{{ activite.organisme.code }}</span>
          </div>
        </div>
        <section class="mt-pax-subscribed mt-bottom">
          <mt-pax-decompte :avancement="activite.avancement" />
          <article>
            <mt-progress-pax-sub
              v-for="(effectif, index) in activite.effectifs"
              :key="index"
              class="mt-progress-pax"
              :pax="effectif"
            />
          </article>
        </section>
        <div v-if="autresUnites">
          <div v-for="(activiteEnfant, index) in activitesEnfants" :key="index" class="mt-bottom">
            <div class="mt-pax-subscribed bartext">
              <span class="is-size-9 has-text-weight-semibold">{{ activiteEnfant.organisme.code }}</span>
              <mt-pop-up-contact :organisme="activiteEnfant.organisme"></mt-pop-up-contact>
            </div>
            <section class="mt-pax-subscribed">
              <mt-pax-decompte :avancement="activiteEnfant.avancement" />
              <article>
                <mt-progress-pax-sub
                  v-for="(effectif, index2) in activiteEnfant.effectifs"
                  :key="index2"
                  class="mt-progress-pax"
                  :pax="effectif"
                />
              </article>
            </section>
          </div>
        </div>
      </div>
    </div>
    <section class="mt-pax">
      <div class="columns">
        <article v-for="(etape, index) in etapes" :key="`etape${index}`" class="column etapes">
          <mt-box-pax-activity
            v-for="(etapeStatut, index2) in etape.etapesStatuts"
            :key="`etapeStatut${index2}`"
            :etape-statut="etapeStatut"
            :activite="activite"
            :etapes-enfants="etapesEnfants"
            :autres-unites="autresUnites"
            :index="{ etape: index, etapeStatut: index2 }"
            @filtrer-etape="filterCategorieEtapesStatuts"
            @unfilter-etape="unfilterCategorieEtapesStatuts"
          >
            {{ etapeStatut.statut.nom }}
          </mt-box-pax-activity>
        </article>
      </div>
      <mt-message-info v-if="activite.avancement.taux.nombre > 0"
        >L'effectif des "convoqués" peut diverger de l'effectif "activité réalisée" si ceux-ci ont été absents le jour
        de l'activité.</mt-message-info
      >
    </section>

    <section v-if="commentaires.length > 0" class="mt-pax mt-separation">
      <div class="columns is-centered">
        <div class="mt-commentaires column is-half is-flex">
          <p><b>Commentaires</b>{{ commentaires.length }}</p>
          <mt-commentaire
            v-for="(comment, index) in commentaires"
            :key="`comment${index}`"
            is-fil-de-discustion
            :commentaire="comment"
            :redacteur="comment.redacteur"
          />
        </div>
      </div>
    </section>
    <mt-modal-action :ouvert.sync="openAction" message-expanded>
      Êtes-vous certain(e) de vouloir confirmer votre action ?<br />

      <br />
      <form @submit.prevent="activerChoix">
        <div class="columns is-mobile is-4 is-variable">
          <div class="column is-narrow">
            <mt-pastille v-if="utilisateur" is-blue>{{ utilisateur.initial }}</mt-pastille>
          </div>
          <div class="column">
            <b-field label="commentaire">
              <b-input
                v-model="commentaireAction"
                maxlength="150"
                type="textarea"
                placeholder="Ajoutez un commentaire."
                has-counter
                :required="isAnnulation"
              ></b-input>
            </b-field>
          </div>
        </div>
        <article class="field is-grouped is-grouped-centered">
          <div class="columns">
            <p class="control column">
              <b-button
                class="mt-button is-size-8"
                type="is-secondary"
                native-type="button"
                @click="openAction = false"
              >
                annuler
              </b-button>
            </p>
            <p class="control column">
              <b-button class="mt-button is-size-8" type="is-primary" native-type="submit">
                {{ choixNom }}
              </b-button>
            </p>
          </div>
        </article>
      </form>
      <template #buttons> <div></div></template>
    </mt-modal-action>

    <mt-modal-ok :ouvert.sync="openPopup">
      Pour vous désinscrire vous devez prendre contact avec votre supérieur hiérarchique
    </mt-modal-ok>
    <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="deleteActivite">
      Êtes-vous certain(e) de vouloir supprimer l’activité ?
      <div class="column">
        <b-field class="commentaire" label="commentaire(facultatif)">
          <b-input
            v-model="commentaire"
            type="textarea"
            placeholder="Ajoutez un commentaire"
            class="mt-input"
            maxlength="500"
          >
          </b-input>
        </b-field>
      </div>
    </mt-modal-action>

    <mt-modal-ok :ouvert.sync="ouvertOkDelete" @action="retourAccueil">
      L’activité a bien été supprimée.
    </mt-modal-ok>

    <mt-modal-action :ouvert.sync="ouvertShare" size="950px" message-expanded>
      <form @submit.prevent="shareActivite">
        <div class="mt-fields-section mt-no-center">
          <b-field class="mt-fields-section" label="Partager l’activité à d'autres unités">
            <span
              >Vous pouvez demander du renfort à d'autres unités. Pour cela, sélectionnez dans le menu déroulant les
              unités à solliciter. Les super-employeurs (CDU) recevront alors un e-mail avec un lien leur permettant de
              créer une activité liée à la vôtre. Vous verrez les participants venant d'autres unités à la consultation
              de votre activité.</span
            >
          </b-field>
          <b-field class="mt-fields-section" label="Choisir une ou plusieurs unités">
            <b-autocomplete
              v-model="searchOrganisme"
              :data="filteredDataArray()"
              placeholder="Sélectionnez une ou plusieurs unités"
              icon-right="menu-down"
              open-on-focus
              clearable
            >
              <template #empty>aucun résultat</template>
              <template #default="{ option }">
                <article class="columns is-mobile">
                  <div class="column is-narrow" @click="ajouter(option)">
                    <span class="is-selected" :class="isAutoCompleteSelected(option)"
                      ><b-icon icon="check-circle"></b-icon>
                    </span>
                  </div>
                  <div class="column" @click="ajouter(option)">
                    {{ option.libelle }} <b>[{{ option.codeParent }}/{{ option.code }}]</b>
                  </div>
                </article>
              </template>
            </b-autocomplete>
          </b-field>
          <section class="mt-liste-selected">
            <div v-for="(organisme, index) in organismesSelected" :key="`tag${index}`">
              <b-tag class="mt-selected" closable @close="removeSelectedOrganisme(index)">
                {{ organisme.code }}
              </b-tag>
              <mt-message-warning v-if="organisme.contacts.length == 0">
                Attention, l'unité que vous avez sélectionnée n'a pas de super-employeurs, personne ne recevra votre
                demande de renfort.
              </mt-message-warning>
              <b-input
                v-if="organisme.contacts.length > 0"
                v-model="organisme.commentaire"
                type="textarea"
                rows="2"
                placeholder="Renseignez vos besoins en effectif ou autres informations que vous souhaitez transmettre à l'unité."
                class="mt-input marge"
                maxlength="200"
              />
            </div>
          </section>
          <article class="field is-grouped is-grouped-centered">
            <p class="control">
              <b-button class="mt-button is-size-8 has-text-weight-semibold" @click="closeShare">
                Annuler
              </b-button>
            </p>
            <p class="control">
              <b-button class="mt-button is-size-8 has-text-weight-semibold" type="is-primary" native-type="submit">
                Partager l'activité
              </b-button>
            </p>
          </article>
        </div>
      </form>
      <template #buttons> <div></div></template>
      <template v-slot:footer>
        <div class="mt-fields-section mt-no-center">
          <hr />
          <b-field class="mt-fields-section" label="Lien de l'activité">
            <div class="columns">
              <b-input v-model="shareUrl" icon="link-variant" class="column" expanded></b-input>
              <p class="control column is-narrow">
                <b-button
                  class="mt-button is-size-8 has-text-weight-semibold "
                  type="is-secondary"
                  icon-left="content-copy"
                  title="copier le lien"
                  @click="copy"
                  >copier le lien
                </b-button>
              </p>
            </div>
          </b-field>
          <mt-message-info>
            Vous pouvez également faire parvenir directement ce lien aux super employeurs (CDU) de votre choix. Les
            super-employeurs (CDU) recevront ce lien leur permettant ainsi de créer une activité liée à la vôtre. Vous
            verrez les participants venant d’autres unités à la consultation de votre activité.
          </mt-message-info>
        </div>
      </template>
    </mt-modal-action>
    <mt-modal-ok :ouvert.sync="ouvertConfirm">
      Un e-mail d'invitation a été envoyé au(x) unité(s) séléctionnée(s).
    </mt-modal-ok>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtTagButtonActivity from '~/components/activity/tag-button-activity';
import MtDateRangeLong from '~/components/activity/date-range-long';
import MtProgressPaxSub from '~/components/activity/progress-pax-subscribed';
import MtBoxPaxActivity from '~/components/activity/box-pax-activty';
import { classResolver, retourActivite } from '~/components/mixins/activityMixin';
import userMixin from '~/components/mixins/userMixin';
import MtCommentaire from '~/components/activity/partipation/commentaire';
import MtListEtapesEmploye from '~/components/activity/partipation/liste-etapes-employe';
import MtMessageInfo from '~/components/base/message/mt-message-info';
import MtMessageWarning from '~/components/base/message/mt-message-warning';
import MtModalAction from '~/components/modal/mt-modal-action';
import MtPastille from '~/components/base/pastille/index';
import newParticiper from '~/components/mixins/participerMixin';
import needVerification from '~/components/mixins/choixMixin';
import MtUnite from '~/components/activity/unite';
import MtPaxDecompte from '~/components/activity/pax-decompte';
import MtModalOk from '~/components/modal/mt-modal-ok';
import MtPopUpContact from '~/components/activity/popup-contact';

export default {
  layout: 'sans-container',
  components: {
    MtPopUpContact,
    MtPastille,
    MtModalAction,
    MtPaxDecompte,
    MtUnite,
    MtMessageInfo,
    MtMessageWarning,
    MtListEtapesEmploye,
    MtCommentaire,
    MtPageTitle,
    MtTagButtonActivity,
    MtDateRangeLong,
    MtProgressPaxSub,
    MtBoxPaxActivity,
    MtModalOk,
  },
  mixins: [classResolver, userMixin, retourActivite],
  data() {
    return {
      openSeDesinscrire: false,
      openAction: false,
      actionSelectionner: null,
      choixNom: '',
      commentaireAction: null,
      openPopup: false,
      bouton: false,
      commentairePopup: false,
      autresUnites: false,
      ouvertDelete: false,
      ouvertOkDelete: false,
      ouvertShare: false,
      commentaire: null,
      organismesSelected: [],
      searchOrganisme: '',
      ouvertConfirm: false,
    };
  },
  computed: {
    detailType() {
      return this.resolveTypeActivite(this.activite, 'mt-background-type-');
    },
  },
  watch: {
    isEmploye: {
      async handler() {
        this.maParticipation = {};
        if (this.isEmploye) {
          try {
            this.maParticipation = await this.$api.utilisateurs.maParticipation(this.activite.id);
          } catch (ignored) {
            // je ne participe pas à l'activite.
          }
        }
      },
      immediate: true,
    },
  },
  async asyncData(context) {
    const visu = context.query && context.query.visu ? context.query.visu : null;
    const isEmploye = context.store.getters['context/isEmploye'];
    let commentaires = [];
    let maParticipation = {};
    let autresActivites = [];
    if (isEmploye) {
      try {
        [commentaires, maParticipation, autresActivites] = await Promise.all([
          context.$api.activites.mesCommentairesEmploye(context.params.id),
          context.$api.utilisateurs.maParticipation(context.params.id),
          context.$api.utilisateurs.mesAutresActivites(context.params.id),
        ]);
      } catch (ignored) {
        // je ne participe pas à l'activite.
      }
    }
    const [activite, etapes] = await Promise.all([
      context.$api.activites.get(context.params.id),
      context.$api.etapes.employe(),
    ]);
    const shareUrl = `https://${window.location.host}/${activite.token}/activite-redirect-partage`;
    let activiteParent = null;
    if (activite.idParent) {
      activiteParent = await context.$api.activites.getParent(context.params.id);
    }
    const activitesEnfants = await context.$api.activites.getEnfants(context.params.id);
    const avancementTotal = JSON.parse(JSON.stringify(activite.avancement));
    const etapesEnfants = [];
    for (let j = 0; j < activitesEnfants.length; j += 1) {
      avancementTotal.taux.nombre += activitesEnfants[j].avancement.taux.nombre;
      avancementTotal.taux.total += activitesEnfants[j].avancement.taux.total;
      etapesEnfants.push({});
      etapesEnfants[j].organisme = activitesEnfants[j].organisme;
      etapesEnfants[j].etapes = JSON.parse(JSON.stringify(etapes));
    }

    avancementTotal.taux.pourcentage = (avancementTotal.taux.nombre / avancementTotal.taux.total) * 100;
    const effectifTotal = JSON.parse(JSON.stringify(activite.effectifs));
    for (let i = 0; i < 3; i += 1) {
      for (let j = 0; j < activitesEnfants.length; j += 1) {
        effectifTotal[i].avancement.nombre += activitesEnfants[j].effectifs[i].avancement.nombre;
        effectifTotal[i].avancement.total += activitesEnfants[j].effectifs[i].avancement.total;
        effectifTotal[i].nombre += activitesEnfants[j].effectifs[i].nombre;
      }
      effectifTotal[i].avancement.pourcentage =
        (effectifTotal[i].avancement.nombre / effectifTotal[i].avancement.total) * 100;
    }

    let participantsReq = [];
    etapes.forEach((etape) => {
      etape.etapesStatuts.forEach((etapeStatut) => {
        participantsReq.push(context.$api.activites.statut(activite.id, etapeStatut.statut.id));
      });
    });
    let participantsRes = await Promise.all(participantsReq);
    let k = -1;
    for (let i = 0; i < etapes.length; i += 1) {
      for (let j = 0; j < etapes[i].etapesStatuts.length; j += 1) {
        k += 1;
        etapes[i].etapesStatuts[j].partipantLoaded = participantsRes[k];
      }
    }
    const participer = await context.$api.participer.participationUtilisateur(
      context.params.id,
      context.store.state.auth.user.id,
    );
    const participationFiltre = participer.avancements.filter(
      (val) => val.choix && val.choix.code !== undefined && val.choix.code !== null,
    );
    let isConvoque = false;
    let isAnnulation = false;
    if (participationFiltre.length > 0) {
      isConvoque =
        participationFiltre[participationFiltre.length - 1].choix.code === 'convoquer' ||
        participationFiltre[participationFiltre.length - 1].choix.code === 'annuler-non-convoques';
      isAnnulation =
        participationFiltre[participationFiltre.length - 1].choix.code === 'candidater' ||
        participationFiltre[participationFiltre.length - 1].choix.code === 'retenir';
    }

    participantsReq = [];
    for (let l = 0; l < activitesEnfants.length; l += 1) {
      etapesEnfants[l].etapes.forEach((etape) => {
        etape.etapesStatuts.forEach((etapeStatut) => {
          participantsReq.push(context.$api.activites.statut(activitesEnfants[l].id, etapeStatut.statut.id));
        });
      });
    }
    participantsRes = await Promise.all(participantsReq);
    k = -1;
    for (let l = 0; l < activitesEnfants.length; l += 1) {
      for (let i = 0; i < etapesEnfants[l].etapes.length; i += 1) {
        for (let j = 0; j < etapesEnfants[l].etapes[i].etapesStatuts.length; j += 1) {
          k += 1;
          etapesEnfants[l].etapes[i].etapesStatuts[j].partipantLoaded = participantsRes[k];
        }
      }
    }
    const organismes = await context.$api.organismes.organismesAllowedForPartageActivite(context.params.id);
    return {
      maParticipation,
      activite,
      activiteParent,
      activitesEnfants,
      etapes,
      commentaires,
      autresActivites,
      avancementTotal,
      etapesEnfants,
      effectifTotal,
      visu,
      organismes,
      shareUrl,
      isConvoque,
      isAnnulation,
    };
  },
  methods: {
    openPopUpAction(action) {
      this.choixNom = action.choix.nom;
      this.actionSelectionner = action;
      this.openAction = true;
    },
    async activerChoix() {
      this.openAction = false;
      await this.$api.participer.monChoix(this.getParticiper());
      this.commentaireAction = '';
      await this.refreshEtape();
    },
    async refreshEtape() {
      if (this.isEmploye) {
        [this.commentaires, this.maParticipation] = await Promise.all([
          this.$api.activites.mesCommentairesEmploye(this.activite.id),
          this.$api.utilisateurs.maParticipation(this.activite.id),
        ]);
        await this.refreshEtapesStatuts();
      }
      await this.filtreParticipation();
    },
    async refreshEtapesStatuts() {
      const participantsReq = [];

      for (let i = 0; i < this.etapes.length; i += 1) {
        for (let j = 0; j < this.etapes[i].etapesStatuts.length; j += 1) {
          participantsReq.push(this.getApi({ etape: i, etapeStatut: j }));
        }
      }

      const participantsRes = await Promise.all(participantsReq);

      let k = -1;
      for (let i = 0; i < this.etapes.length; i += 1) {
        for (let j = 0; j < this.etapes[i].etapesStatuts.length; j += 1) {
          k += 1;
          this.etapes[i].etapesStatuts[j].partipantLoaded = participantsRes[k];
        }
      }
    },
    unfilterCategorieEtapesStatuts({ index: { etape, etapeStatut } }) {
      this.etapes[etape].etapesStatuts[etapeStatut].categeorieSelected = null;
      for (let l = 0; l < this.activitesEnfants.length; l += 1) {
        this.etapesEnfants[l].etapes[etape].etapesStatuts[etapeStatut].categeorieSelected = null;
      }
      this.relaodEtapesStatuts({ etape, etapeStatut });
    },
    filterCategorieEtapesStatuts({ categorie, index: { etape, etapeStatut } }) {
      this.etapes[etape].etapesStatuts[etapeStatut].categeorieSelected = categorie;
      for (let l = 0; l < this.activitesEnfants.length; l += 1) {
        this.etapesEnfants[l].etapes[etape].etapesStatuts[etapeStatut].categeorieSelected = categorie;
      }
      this.relaodEtapesStatuts({ etape, etapeStatut });
    },
    async relaodEtapesStatuts({ etape, etapeStatut }) {
      this.etapes[etape].etapesStatuts[etapeStatut].partipantLoaded = await this.getApi({
        etape,
        etapeStatut,
      });
      const req = [];
      for (let l = 0; l < this.activitesEnfants.length; l += 1) {
        req.push(this.getApiEnfants(this.activitesEnfants[l], etape, etapeStatut));
      }
      const res = await Promise.all(req);
      for (let l = 0; l < this.activitesEnfants.length; l += 1) {
        this.etapesEnfants[l].etapes[etape].etapesStatuts[etapeStatut].partipantLoaded = res[l];
      }
    },
    async filtreParticipation() {
      const participer = await this.$api.participer.participationUtilisateur(this.activite.id, this.utilisateur.id);
      const participationFiltre = participer.avancements.filter(
        (val) => val.choix && val.choix.code !== undefined && val.choix.code !== null,
      );
      this.isConvoque = false;
      this.isAnnulation = false;
      if (participationFiltre.length > 0) {
        this.isConvoque =
          participationFiltre[participationFiltre.length - 1].choix.code === 'convoquer' ||
          participationFiltre[participationFiltre.length - 1].choix.code === 'annuler-non-convoques';
        this.isAnnulation =
          participationFiltre[participationFiltre.length - 1].choix.code === 'candidater' ||
          participationFiltre[participationFiltre.length - 1].choix.code === 'retenir';
      }
    },
    getApi({ etape, etapeStatut }) {
      const { statut, categeorieSelected } = this.etapes[etape].etapesStatuts[etapeStatut];
      let idCatgegorie = null;
      if (categeorieSelected) {
        idCatgegorie = categeorieSelected.id;
      }
      return this.$api.activites.statut(this.activite.id, statut.id, idCatgegorie);
    },
    getApiEnfants(activite, etape, etapeStatut) {
      const { statut, categeorieSelected } = this.etapes[etape].etapesStatuts[etapeStatut];
      let idCatgegorie = null;
      if (categeorieSelected) {
        idCatgegorie = categeorieSelected.id;
      }
      return this.$api.activites.statut(activite.id, statut.id, idCatgegorie);
    },
    getParticpant() {
      return {
        utilisateur: this.utilisateur,
        commentaire: this.commentaireAction,
      };
    },
    getParticiper() {
      const participer = newParticiper();
      participer.activite = this.activite;
      participer.choix = this.actionSelectionner.choix;
      participer.validateur = this.utilisateur;
      participer.selectionnees.push(this.getParticpant());

      return participer;
    },
    maParticipationTitle({ choix }) {
      if (this.disabledAction({ choix })) {
        return 'Vous participez déjà à une autre activité.';
      }
      return '';
    },
    disabledAction({ choix }) {
      if (needVerification(choix)) {
        return this.autresActivites.length > 0;
      }
      return false;
    },
    actionPopup() {
      this.openPopup = true;
    },
    voirAutresUnites() {
      this.autresUnites = !this.autresUnites;
    },
    dupliquer() {
      this.$router.push(
        this.profilLink({
          name: 'activites-id-dupliquer',
          params: { id: this.activite.id },
        }),
      );
    },
    deleteActivite() {
      try {
        this.$api.activites.delete(this.activite.id, this.commentaire);
        this.ouvertOkDelete = true;
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    retourAccueil() {
      this.$router.push(
        this.profilLink({
          name: this.page,
          query: { mois: this.queryMois },
        }),
      );
    },
    closeShare() {
      this.ouvertShare = false;
    },
    async shareActivite() {
      try {
        if (this.organismesSelected.length > 0) {
          let nbContacts = 0;
          this.organismesSelected.forEach((org) => {
            nbContacts += org.contacts.length;
          });
          if (nbContacts > 0) {
            this.activite = await this.$api.activites.partage(this.activite.id, this.organismesSelected);
            this.ouvertConfirm = true;
            this.ouvertShare = false;
          } else {
            this.$buefy.notification.open({
              message: "Les unités que vous avez sélectionnées n'ont pas de super-employeurs.",
              type: 'is-warning',
              duration: 5000,
            });
          }
        } else {
          this.$buefy.notification.open({
            message: 'Vous devez sélectionner au moins une unité.',
            type: 'is-warning',
            duration: 5000,
          });
        }
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    getListeOrganisme() {
      const organismes = new Map();
      this.organismes.forEach(function setOrganismes(organisme) {
        let tabOrg = organismes.get(organisme.codeParent);
        if (!tabOrg) {
          tabOrg = [];
        }
        tabOrg.push(organisme);
        organismes.set(organisme.codeParent, tabOrg);
      });
      const ret = [];
      const org = Array.from(organismes);
      for (let i = 0; i < org.length; i += 1) {
        ret.push({ parent: org[i][0], enfants: org[i][1] });
      }
      return ret;
    },
    copy() {
      this.$copyText(this.shareUrl).then(
        () => {
          this.$buefy.toast.open({
            message: `"${this.shareUrl}" copié dans le presse papier`,
            type: 'is-success',
          });
        },
        () => {
          this.$buefy.toast.open({
            message: `Impossible de copié dans le presse papier`,
            type: 'is-danger',
          });
        },
      );
    },
    ajouter(option) {
      if (!this.organismesSelected.find((value) => value.id === option.id)) {
        this.organismesSelected.push(option);
      }
      this.searchOrganisme = '';
    },
    isAutoCompleteSelected(option) {
      const search = this.organismesSelected.find((value) => value.id === option.id);
      if (search) {
        return 'mt-list-item-selected';
      }
      return '';
    },
    removeSelectedOrganisme(index) {
      this.organismesSelected.splice(index, 1);
    },
    filteredDataArray() {
      return this.organismes.filter((option) => {
        if (this.searchOrganisme) {
          return (
            option.code
              .toString()
              .toLowerCase()
              .includes(this.searchOrganisme.toLowerCase()) ||
            option.libelle
              .toString()
              .toLowerCase()
              .includes(this.searchOrganisme.toLowerCase())
          );
        }
        return this.organismes;
      });
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-row-container-small-blue-pale {
  height: 75%;
  background-color: $pale-grey-two;
  z-index: -1;
  top: 25%;
  @include mt-row-container-small;
}
.mt-date-range {
  position: relative;
  background-color: $pale-grey-two;
}
.mt-modifier {
  padding: 2rem 0;
}
.mt-pax {
  background-color: $pale-grey-two;
  padding: 2rem 5vw;
  justify-content: stretch;

  &.margin-negative {
    margin-top: -1.5rem;
    padding: 0 0 2rem;
    margin-bottom: 3rem;
  }

  &.mt-separation {
    border-top: 1px solid #e9eefe;
  }

  /deep/ .column.etapes {
    display: flex;
    margin: 0 1vw;
  }

  .mt-box {
    flex-grow: 1;
  }

  /deep/ .mt-info {
    margin: 1rem 1.5rem 0;
  }
}
.mt-pax-subscribed {
  text-align: center;
  display: flex;
  align-items: center;
  justify-content: center;
  margin-top: 1rem;
  &:hover {
    .mt-pop-up-contact {
      display: flex;
      flex-direction: column;
      align-items: flex-start;
    }
  }
}
@media (max-width: 768px) {
  .mt-pax-subscribed {
    margin-left: 1rem;
  }
}
.mt-progress-pax {
  flex-direction: row;
  align-items: center;
}
/deep/ hr {
  margin: 1rem 0 1.5rem 0;
}
.mt-subtitle {
  margin-bottom: 0;
  align-items: flex-end;
}
.mt-description {
  max-width: 674px;
  margin: 2rem 0;
}

.mt-commentaires {
  display: flex;
  flex-direction: column;

  p {
    color: $grey-dark;
    font-size: 0.75rem;
    margin: 0 0.75rem;
  }
  b {
    padding-right: 0.75rem;
  }
}
.mt-margin-top {
  margin-top: 1.5rem;
}
/deep/.mt-type .button {
  border-radius: 2rem;
  background-color: $primary;
  color: white;
  font-size: $size-7;
  padding: 1.3em 1em;
  cursor: pointer;
  transition-property: background-color, color;
  transition-duration: 0.3s;
  border: solid 1px $primary;
  position: relative;
  left: 4px;
  &.is-primary {
    background-color: $pale-grey;
    color: #666ee8;
  }
  &:hover {
    background-color: $periwinkle-blue;
    color: white;
  }
}
.bartext {
  height: 3px;
  width: 100%;
  padding: 0px;
  background: #666ee8;
  overflow: visible;
  position: relative;
  margin-top: 24px;
}
.bartext span {
  color: #666ee8;
  background-color: #ffffff;
  top: -10px;
  padding: 0 8px 8px 8px;
  display: inline;
  position: absolute;
}
.mt-participation {
  display: inline-block;
  padding-bottom: 20px;
}
.mt-center {
  text-align: center;
}
.mt-bottom {
  padding-bottom: 20px;
}
.mt-inline {
  position: relative;
  display: inline-flex;
}
.mt-no-center {
  text-align: left !important;
}
.mt-groupe-lien {
  display: flex;
  justify-content: space-between;
  margin: 0.3em 0 0.3em 2rem;
}
.is-selected {
  color: #dfdfdf;

  &.mt-list-item-selected {
    color: $soft-blue;
  }
}
.mt-liste-selected {
  padding: 0 0 1em;
  align-items: center;
}
.mt-selected {
  background-color: $pale-grey;
  color: #666ee8;
  padding: 0.5em 1em;
  margin: 0.25em;
  font-size: 0.6875rem;
  cursor: default;
}
.mt-margin {
  margin: 1em;
}
.popup {
  &:hover {
    .mt-pop-up-contact {
      top: 15px !important;
      display: flex;
      flex-direction: column;
      align-items: flex-start;
    }
  }
}
.mt-unit-parent {
  padding-left: 20px;
}
/deep/ .modal-content {
  overflow: auto;
}
.mt-preline {
  white-space: pre-line;
}
</style>
